/* 

// 	07.08.20011    
// 	ADC-Test unsigned 12 Bit mit Offset-Korr!!!!!!!!!!!!
	
//	CodeWizardAVR V2.05.3 Evaluation
//	Automatic Program Generator
//	 Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
//	http://www.hpinfotech.com

//  Display EA DOGM132
//	Library fr EA-DOGM Grafikdisplays inkl. Font-Generator
//	Autor: Jan M. (mueschel
//	http://www.mikrocontroller.net/topic/144500#new


// 	** Achtung bitte eigenen Takt einstellen! **

// 	hier: Atxmega128a3   	: Internal 32 MHz RC oscillator 
//	AVR Core Clock frequency: 16,000000 MHz


// Wichtig LCD_CS 10K Widerstand nach 3,3V!!

//	Atxmega32a4					DOGS102				DOGM128/132
// ----------------------------------------------------------------------
// LCD_A0      PC2 (Pin 12) -> 	A0		PIN 26		A0		PIN 38	
// LCD_RST     PC3 (Pin 13) ->	RST		PIN 27 		RST		PIN 39
// LCD_CS      PC4 (Pin 14) -> 	CS0		PIN 28 		CS0		PIN 40 
// SPI_MOSI    PC5 (Pin 15) -> 	MOSI	PIN 24		MOSI	PIN 36
// SPI_MISO      
// SPI_SCK     PC7 (Pin 17) -> 	SCK		PIN 25		SCK		PIN 37

//	Atxmega128a1/Atxmega128a3	DOGS102				DOGM128/132
//----------------------------------------------------------------------
// LCD_A0      PC2 (Pin 18)	->	A0		PIN 26		A0		PIN 38
// LCD_RST     PC3 (Pin 19)	->	RST		PIN 27 		RST		PIN 39
// LCD_CS      PC4 (Pin 20)	->	CS0		PIN 28 		CS0		PIN 40 
// SPI_MOSI    PC5 (Pin 21)	->	MOSI	PIN 24		MOSI	PIN 36
// SPI_MISO    
// SPI_SCK     PC7 (Pin 23)	->	SCK		PIN 25		SCK		PIN 37




*/


#include "tools.h"

#define ADCACAL0_offset 0x20	// zum Auslesen ADC Offset aus Flash
#define ADCACAL1_offset 0x21	// dsgl


static FILE mystdout = FDEV_SETUP_STREAM(dogm128_putchar, NULL, _FDEV_SETUP_WRITE); // bindet printf() ein

unsigned char adca_offset;


int main(void)
{


	stdout = &mystdout; // bindet printf() ein 
	system_clocks_init(); // System Clocks initialization
	

	// Enable HI/MED/LO interrupt level
	// Interupt einschalten
	PMIC.CTRL |= PMIC_HILVLEN_bm; 
	PMIC.CTRL |= PMIC_MEDLVLEN_bm;
	PMIC.CTRL |= PMIC_LOLVLEN_bm;
	
	sei(); 

	SPI_PORT_Init(); 	// SPI Port Init
 	SPI_Init();			// SPI Init
	lcd_init();			// DOGM Init
	delay_ms(10);  		// 10ms warten Display Init
	
	lcd_set_font(FONT_PROP_8, NORMAL); 		// fr printf vorbereiten

	lcd_moveto_xy(0,0); printf("ADC-Test Unsigned"); // Anzeige Start
	
	PORTA.OUT |=0x00; // PORTA als Eingang
	PORTA.DIR |=0x00;

	adca_init();


	unsigned int adca_data;
		while(true) 
		{  
		
		adca_data =adca_read(0); // ADCA Kanal 0 lesen
		delay_ms(100);
		
		lcd_moveto_xy(1,0);		// ADC Kalibrierwert aus Flash in Hex
		printf("Kalibrierwert = %x ",ADCA.CAL);

		lcd_moveto_xy(2,0);		// ADC Offset aus Flash in Volt
		printf("Offset: %.06f V",(adca_offset*(1.0/4096.0)));
		
		lcd_moveto_xy(3,0); //  ADC Anzeige 
		printf("Ausgabe: %.03f V",(adca_data * (1.0/4096.0)));
		
	
		

		nop();
		
		}		


		return (0);
}

void system_clocks_init(void)
{
unsigned char n,s;

// Save interrupts enabled/disabled state
s=SREG;
// Disable interrupts
cli();

// Internal 32 MHz RC oscillator initialization
// Enable the internal 32 MHz RC oscillator
OSC.CTRL|=OSC_RC32MEN_bm;

// System Clock prescaler A division factor: 2
// System Clock prescalers B & C division factors: B:1, C:1
// ClkPer4: 16000,000 kHz
// ClkPer2: 16000,000 kHz
// ClkPer:  16000,000 kHz
// ClkCPU:  16000,000 kHz
n=(CLK.PSCTRL & (~(CLK_PSADIV_gm | CLK_PSBCDIV1_bm | CLK_PSBCDIV0_bm))) |
	CLK_PSADIV_2_gc | CLK_PSBCDIV_1_1_gc;
CCP=CCP_IOREG_gc;
CLK.PSCTRL=n;

// Disable the autocalibration of the internal 32 MHz RC oscillator
DFLLRC32M.CTRL&= ~DFLL_ENABLE_bm;

// Wait for the internal 32 MHz RC oscillator to stabilize
while ((OSC.STATUS & OSC_RC32MRDY_bm)==0);

// Select the system clock source: 32 MHz Internal RC Osc.
n=(CLK.CTRL & (~CLK_SCLKSEL_gm)) | CLK_SCLKSEL_RC32M_gc;
CCP=CCP_IOREG_gc;
CLK.CTRL=n;

// Disable the unused oscillators: 2 MHz, internal 32 kHz, external clock/crystal oscillator, PLL
OSC.CTRL&= ~(OSC_RC2MEN_bm | OSC_RC32KEN_bm | OSC_XOSCEN_bm | OSC_PLLEN_bm);

// Peripheral Clock output: Disabled
PORTCFG.CLKEVOUT=(PORTCFG.CLKEVOUT & (~PORTCFG_CLKOUT_gm)) | PORTCFG_CLKOUT_OFF_gc;

// Restore interrupts enabled/disabled state
SREG=s;
// Restore optimization for size if needed

}



int dogm128_putchar(char c, FILE *stream) // // bindet printf() ein
{
 	lcd_putc(c);
    return 0;
}

// ADCA initialization

// Variable used to store the ADC offset
// for 12 Bit Unsigned conversion mode


void adca_init(void)
{

unsigned char i;
unsigned int offs;


// calibration_byte aus Flash
ADCA.CALL=read_calibration_byte(PROD_SIGNATURES_START+ADCACAL0_offset); 
ADCA.CALH=read_calibration_byte(PROD_SIGNATURES_START+ADCACAL1_offset);

// Conversion mode: Unsigned
ADCA.CTRLB=(ADCA.CTRLB & (~(ADC_CONMODE_bm | ADC_FREERUN_bm | ADC_RESOLUTION_gm))) |
	ADC_RESOLUTION_12BIT_gc;

// Clock frequency: 125,000 kHz
ADCA.PRESCALER=(ADCA.PRESCALER & (~ADC_PRESCALER_gm)) | ADC_PRESCALER_DIV128_gc;

// Reference: Internal 1.00 V
// Temperature reference: On
ADCA.REFCTRL=(ADCA.REFCTRL & ((~(ADC_REFSEL_gm | ADC_TEMPREF_bm)) | ADC_BANDGAP_bm)) |
	ADC_REFSEL_INT1V_gc | ADC_TEMPREF_bm | ADC_BANDGAP_bm;

// Read and save the ADC offset using channel 0
// ADC0 pin connected to GND
ADCA.CH0.CTRL=(ADCA.CH0.CTRL & (~(ADC_CH_START_bm | ADC_CH_GAINFAC_gm | ADC_CH_INPUTMODE_gm))) |
	ADC_CH_INPUTMODE_SINGLEENDED_gc;
ADCA.CH0.MUXCTRL=(ADCA.CH0.MUXCTRL & (~(ADC_CH_MUXPOS_gm | ADC_CH_MUXNEG_gm))) |
	ADC_CH_MUXPOS_PIN0_gc;
// Enable the ADC in order to read the offset
ADCA.CTRLA|=ADC_ENABLE_bm;
// Insert a delay to allow the ADC common mode voltage to stabilize
delay_us(2);
// Perform several offset measurements and store the mean value
offs=0;
for (i=0; i<16; i++)
    {
    // Start the AD conversion on channel 0
    ADCA.CH0.CTRL|=ADC_CH_START_bm;
    // Wait for the AD conversion to complete
    while ((ADCA.CH0.INTFLAGS & ADC_CH_CHIF_bm)==0);
    // Clear the interrupt flag
    ADCA.CH0.INTFLAGS=ADC_CH_CHIF_bm;
    // Read the offset
    offs+=(unsigned char) ADCA.CH0.RESL;
    }
// Disable the ADC
ADCA.CTRLA&= ~ADC_ENABLE_bm;
// Store the mean value of the offset
adca_offset=(unsigned char) (offs/16);

// Initialize the ADC Compare register
ADCA.CMPL=0x00;
ADCA.CMPH=0x00;

// ADC channel 0 gain: 1
// ADC channel 0 input mode: Single-ended positive input signal
ADCA.CH0.CTRL=(ADCA.CH0.CTRL & (~(ADC_CH_START_bm | ADC_CH_GAINFAC_gm | ADC_CH_INPUTMODE_gm))) |
	ADC_CH_GAIN_1X_gc | ADC_CH_INPUTMODE_SINGLEENDED_gc;

// ADC channel 0 positive input: ADC0 pin
// ADC channel 0 negative input: GND
ADCA.CH0.MUXCTRL=(ADCA.CH0.MUXCTRL & (~(ADC_CH_MUXPOS_gm | ADC_CH_MUXNEG_gm))) |
	ADC_CH_MUXPOS_PIN0_gc;

// ADC channel 1 gain: 1
// ADC channel 1 input mode: Single-ended positive input signal
ADCA.CH1.CTRL=(ADCA.CH1.CTRL & (~(ADC_CH_START_bm | ADC_CH_GAINFAC_gm | ADC_CH_INPUTMODE_gm))) |
	ADC_CH_GAIN_1X_gc | ADC_CH_INPUTMODE_SINGLEENDED_gc;

// ADC channel 1 positive input: ADC1 pin
// ADC channel 1 negative input: GND
ADCA.CH1.MUXCTRL=(ADCA.CH1.MUXCTRL & (~(ADC_CH_MUXPOS_gm | ADC_CH_MUXNEG_gm))) |
	ADC_CH_MUXPOS_PIN1_gc;

// ADC channel 2 gain: 1
// ADC channel 2 input mode: Single-ended positive input signal
ADCA.CH2.CTRL=(ADCA.CH2.CTRL & (~(ADC_CH_START_bm | ADC_CH_GAINFAC_gm | ADC_CH_INPUTMODE_gm))) |
	ADC_CH_GAIN_1X_gc | ADC_CH_INPUTMODE_SINGLEENDED_gc;

// ADC channel 2 positive input: ADC2 pin
// ADC channel 2 negative input: GND
ADCA.CH2.MUXCTRL=(ADCA.CH2.MUXCTRL & (~(ADC_CH_MUXPOS_gm | ADC_CH_MUXNEG_gm))) |
	ADC_CH_MUXPOS_PIN2_gc;

// ADC channel 3 gain: 1
// ADC channel 3 input mode: Single-ended positive input signal
ADCA.CH3.CTRL=(ADCA.CH3.CTRL & (~(ADC_CH_START_bm | ADC_CH_GAINFAC_gm | ADC_CH_INPUTMODE_gm))) |
	ADC_CH_GAIN_1X_gc | ADC_CH_INPUTMODE_SINGLEENDED_gc;

// ADC channel 3 positive input: ADC3 pin
// ADC channel 3 negative input: GND
ADCA.CH3.MUXCTRL=(ADCA.CH3.MUXCTRL & (~(ADC_CH_MUXPOS_gm | ADC_CH_MUXNEG_gm))) |
	ADC_CH_MUXPOS_PIN3_gc;

// ADC is free-running, sweeped channel(s): 0, 1, 2, 3
ADCA.EVCTRL=ADC_SWEEP_0123_gc | ADC_EVACT_NONE_gc;

// Channel 0 interrupt: Disabled
ADCA.CH0.INTCTRL=(ADCA.CH0.INTCTRL & (~(ADC_CH_INTMODE_gm | ADC_CH_INTLVL_gm))) |
	ADC_CH_INTMODE_COMPLETE_gc | ADC_CH_INTLVL_OFF_gc;
// Channel 1 interrupt: Disabled
ADCA.CH1.INTCTRL=(ADCA.CH1.INTCTRL & (~(ADC_CH_INTMODE_gm | ADC_CH_INTLVL_gm))) |
	ADC_CH_INTMODE_COMPLETE_gc | ADC_CH_INTLVL_OFF_gc;
// Channel 2 interrupt: Disabled
ADCA.CH2.INTCTRL=(ADCA.CH2.INTCTRL & (~(ADC_CH_INTMODE_gm | ADC_CH_INTLVL_gm))) |
	ADC_CH_INTMODE_COMPLETE_gc | ADC_CH_INTLVL_OFF_gc;
// Channel 3 interrupt: Disabled
ADCA.CH3.INTCTRL=(ADCA.CH3.INTCTRL & (~(ADC_CH_INTMODE_gm | ADC_CH_INTLVL_gm))) |
	ADC_CH_INTMODE_COMPLETE_gc | ADC_CH_INTLVL_OFF_gc;

// Free Running mode: On
ADCA.CTRLB|=ADC_FREERUN_bm;

// Enable the ADC
ADCA.CTRLA|=ADC_ENABLE_bm;
// Insert a delay to allow the ADC common mode voltage to stabilize
delay_us(2);
}


// ADCA channel data read function using polled mode
signed int adca_read(unsigned char channel)
{
ADC_CH_t *pch=&ADCA.CH0+channel;
signed int data;

// Start the AD conversion
pch->CTRL|=ADC_CH_START_bm;
// Wait for the AD conversion to complete
while ((pch->INTFLAGS & ADC_CH_CHIF_bm)==0);
// Clear the interrupt flag
pch->INTFLAGS=ADC_CH_CHIF_bm;
// Read the AD conversion result
((unsigned char *) &data)[0]=pch->RESL;
((unsigned char *) &data)[1]=pch->RESH;
// Compensate the ADC offset
data-=adca_offset;
return data;
}




uint8_t read_calibration_byte( uint8_t index ) 
{ 
uint8_t result; 

// Load the NVM Command register to read the calibration row.
NVM_CMD = NVM_CMD_READ_CALIB_ROW_gc; 
result = pgm_read_byte(index); 

// Clean up NVM Command register. 
NVM_CMD = NVM_CMD_NO_OPERATION_gc; 

return( result ); 
} 


